module Tests

import TAP
import Tests.DimEq
import Tests.FreeVars
import Tests.Reduce
import Tests.Equal
import Tests.Typechecker
import Tests.PrettyTerm
import Tests.Lexer
import Tests.Parser
import Tests.FromPTerm
import System


allTests : List Test
allTests = [
  DimEq.tests,
  FreeVars.tests,
  Reduce.tests,
  Equal.tests,
  Typechecker.tests,
  PrettyTerm.tests,
  Lexer.tests,
  Parser.tests,
  FromPTerm.tests,
  todo "DimEq",
  todo "Pretty dctx/tctx/tyctx/eqctx"
]

main : IO ()
main = TAP.main !(getTestOpts "quox test suite") ["all" :- allTests]
